class Recorte {

public:

	float xMin, xMax, yMin, yMax, zMin, zMax;

	bool flags_A[6];
	bool flags_B[6];
	bool flags_Vec[6];

	Ponto* ponto_A, *ponto_B;

	Recorte(Ponto* pto_A, Ponto* pto_B, float xmin, float xmax, float ymin, float ymax, float zmin, float zmax) {

		this->ponto_A = pto_A;
		this->ponto_B = pto_B;

		this->xMin = xmin;
		this->xMax = xmax;
		this->yMin = ymin;
		this->yMax = ymax;
		this->zMin = zmin;
		this->zMax = zmax;

		this->flags_A[0] = false;	//a esquerda do xMin
		this->flags_A[1] = false;	//a direita do xMax
		this->flags_A[2] = false;	//abaixo do yMin
		this->flags_A[3] = false;	//acima do xMax
		this->flags_A[4] = false;	//atras do zMin
		this->flags_A[5] = false;	//a frente do zMax

		this->flags_B[0] = false;
		this->flags_B[1] = false;
		this->flags_B[2] = false;
		this->flags_B[3] = false;
		this->flags_B[4] = false;
		this->flags_B[5] = false;

		this->flags_Vec[0] = false;
		this->flags_Vec[1] = false;
		this->flags_Vec[2] = false;
		this->flags_Vec[3] = false;
		this->flags_Vec[4] = false;
		this->flags_Vec[5] = false;

	}
	
	void setarFlags(){

		//x (ponto A)
		if(this->ponto_A->x < this->xMin){

			this->flags_A[0] = true;
			this->flags_A[1] = false;
			
		}else if(this->ponto_A->x > this->xMax){
			
			this->flags_A[0] = false;
			this->flags_A[1] = true;

		}else{

			this->flags_A[0] = false;
			this->flags_A[1] = false;
		}

		//y (ponto A)
		if(this->ponto_A->y < this->yMin){

			this->flags_A[2] = true;
			this->flags_A[3] = false;
			
		}else if(this->ponto_A->y > this->yMax){
			
			this->flags_A[2] = false;
			this->flags_A[3] = true;

		}else{

			this->flags_A[2] = false;
			this->flags_A[3] = false;
		}

		//z (ponto A)
		if(this->ponto_A->z < this->zMin){

			this->flags_A[4] = true;
			this->flags_A[5] = false;
			
		}else if(this->ponto_A->z > this->zMax){
			
			this->flags_A[4] = false;
			this->flags_A[5] = true;

		}else{

			this->flags_A[4] = false;
			this->flags_A[5] = false;
		}

		//x (ponto B)
		if(this->ponto_B->x < this->xMin){

			this->flags_B[0] = true;
			this->flags_B[1] = false;
			
		}else if(this->ponto_B->x > this->xMax){
			
			this->flags_B[0] = false;
			this->flags_B[1] = true;

		}else{

			this->flags_B[0] = false;
			this->flags_B[1] = false;
		}

		//y (ponto B)
		if(this->ponto_B->y < this->yMin){

			this->flags_B[2] = true;
			this->flags_B[3] = false;
			
		}else if(this->ponto_B->y > this->yMax){
			
			this->flags_B[2] = false;
			this->flags_B[3] = true;

		}else{

			this->flags_B[2] = false;
			this->flags_B[3] = false;
		}

		//z (ponto B)
		if(this->ponto_B->z < this->zMin){

			this->flags_B[4] = true;
			this->flags_B[5] = false;
			
		}else if(this->ponto_B->z > this->zMax){
			
			this->flags_B[4] = false;
			this->flags_B[5] = true;

		}else{

			this->flags_B[4] = false;
			this->flags_B[5] = false;
		}

		for(int i = 0; i < 6; i++){
			this->flags_Vec[i] = this->flags_A[i] AND this->flags_B[i];
		}
	}

	
	void verificarCorte(Vetor* vetor){
		
		bool condicao = false;

		for(int i = 0; i < 6; i++) {
			condicao = condicao OR this->flags_Vet[i];
		}

		if(!condicao){
			int index = this->compararFlags()
			while(index < 6){				
					recortar(index)	;				
			}

		}
	}
	int compararFlags(){
		bool retorno = true;
		int i = 0;
		while(retorno && i<6){
			retorno = retorno AND !(this->flags_A[i] XOR this->flags_B[i]);
			i++;
		}
		return i;
	}
	void recortar(int i){
		if(this->flags_A[i]){
			if(i == 0){ // esquerda
			
			}else if(i == 1){ // direita

			}else if(i == 2){ // abaixo
			
			}else if(i == 3){ // acima

			}else if(i == 4){ // atras

			}else if(i == 5){ // a frente

			}
		}else{
			if(i == 0){ // esquerda
			
			}else if(i == 1){ // direita

			}else if(i == 2){ // abaixo
			
			}else if(i == 3){ // acima

			}else if(i == 4){ // atras

			}else if(i == 5){ // a frente

			}	
		}
	}

	Ponto* interseccaoPlanoReta(Reta* reta, Vetor* normal, float d){
		Ponto* retorno;
		//calculando t
		if(produtoEscalar(reta->vetor, normal) != 0){
			float temp = (d - produtoEscalar(reta->inicio, normal))/produtoEscalar(reta->vetor, normal);
			retorno = reta->getPonto(temp);
		}else{
			retorno = NULL;
		}
		return retorno;
	}

};