#include <iostream>
#include <fstream>
#include <string>
#include "Util.h"
using namespace std;

//variaveis globais
Ponto** pontos;
int qntPontos;
Triangulo** faces;
int qntFaces;
//funes
Operacoes* op;
void contarVerticesEFaces(char* arq);
void lerDoArquivo(char* arq);

int main(int argc, char **argv) {

    //cout << "Hello world!" << endl;
	op = new Operacoes();
	lerDoArquivo("cubo.txt");
	Ponto** novosPontos = pontos;
	for(int i = 9 ; i < qntPontos; i++){
		//novosPontos[i] = op->projecaoPlanoVisao(10.0,pontos[i]);
		cout<<i <<" = (" << novosPontos[i]->x<<", "<<novosPontos[i]->y<<", "<<novosPontos[i]->z<<")"<<endl;
	}
	cout << "agora vem o numero de faces! \0/"<<endl;
	for(int j = 0; j < qntFaces; j++){
		cout<<j <<" = (" << faces[j]->indexA<<", "<<faces[j]->indexB<<", "<<faces[j]->indexC<<")"<<endl;
	}


/*

    Ponto* pontoA = new Ponto(1.0, 0.0, 0.0);
    Ponto* pontoB = new Ponto(0.0, 1.0, 0.0);
    Ponto* pontoC = new Ponto(0.0, 0.0, 1.0);

    Vetor* vetor = new Vetor(pontoA,pontoB);


    Matriz* matriz = new Matriz(2,4);
    Operacoes* operacao = new Operacoes();


    matriz->setarElemento(0,0,2);
    matriz->setarElemento(0,1,2);
    matriz->setarElemento(0,2,2);
    matriz->setarElemento(0,3,2);
    matriz->setarElemento(1,0,2);
    matriz->setarElemento(1,1,2);
    matriz->setarElemento(1,2,2);
    matriz->setarElemento(1,3,2);


    for(int i=0; i<4; i++){
        std::cout<< vetor->coord[i];
    }
        std::cout<< endl;

    Vetor* final = operacao->multPorVetor(matriz,vetor);

    for(int i=0; i<4; i++){
        std::cout<< final->coord[i];
    }
    std::cout<< endl;*/
	getchar();
    return 0;
}

void contarVerticesEFaces(char* arq){
	ifstream in;
	in.open(arq);
	//contar vertices
	char lixo[100];
	in.getline(lixo,100);
	while(lixo[0] != '@') in.getline(lixo,100);
	in.getline(lixo,100);
	int contador = 0;
	while(lixo[0] != '@'){
		in.getline(lixo,100);
		contador++;
	}
	qntPontos = 9 + contador;
	//contar faces
	in.getline(lixo,100);
	contador = 0;
	while(lixo[0] != '@'){
		in.getline(lixo,100);
		contador++;
	}
	qntFaces = contador;
	in.close();
}

void lerDoArquivo(char* arq){
	contarVerticesEFaces(arq);
	pontos = new Ponto*[qntPontos];
	faces = new Triangulo*[qntFaces];
	int ppV = 9;
	int ppF = 0;
	ifstream in;
	in.open(arq);
	char elemento[2];
	while(in >> elemento){
		switch (elemento[0]){
		   case '#' : 
			   char comentario[100];
			   in.getline(comentario,100);
			   break;
		   case '@' : 
			   char comentario2[100];
			   in.getline(comentario2,100);
			   break;
		   case 'c' : break;

		   case 'n' : break;

		   case 'w' : break;

		   case 'u' : break;

		   case 'h' : break;
			
		   case 'd' : break;

		   case 'v' : 
			   float valorX;
			   float valorY;
			   float valorZ;
			   in >> valorX;
			   in >> valorY;
			   in >> valorZ;
			   pontos[ppV++] = new Ponto(valorX,valorY,valorZ);
			   break;
			   
		   case 'f' :
			   int indexX;
			   int indexY;
			   int indexZ;
			   in >> indexX;
			   in >> indexY;
			   in >> indexZ;
			   faces[ppF++] = new Triangulo(indexX,indexY,indexZ);
			   break;

		}
	}
	in.close();
}
